﻿using Hotline.FlowEngine.Workflows;
using Hotline.KnowledgeBase;
using Hotline.Share.Dtos;
using Hotline.Share.Dtos.Knowledge;

namespace Hotline.Application.Knowledge
{
    public interface IKnowApplication
    {
        /// <summary>
        ///  流程审批完成，处理知识状态
        /// </summary>
        /// <param name="workflow"></param>
        /// <param name="cancellationToken"></param>
        /// <returns></returns>
        Task EndWorkKnowledge(Workflow workflow, CancellationToken cancellationToken);

        /// <summary>
        /// 知识库查询
        /// </summary>
        /// <param name="pagedDto"></param>
        /// <returns></returns>
        Task<PagedDto<KnowledgeDataDto>> GetKnowList(KnowPagedListDto pagedDto);

        /// <summary>
        /// 知识申请查询
        /// </summary>
        /// <param name="pagedDto"></param>
        /// <param name="cancellationToken"></param>
        /// <returns></returns>
        Task<PagedDto<KnowledgeApply>> GetApplyList(KnowledgeApplyPagedDto pagedDto, CancellationToken cancellationToken);

        /// <summary>
        /// 申请处理查询
        /// </summary>
        /// <param name="pagedDto"></param>
        /// <param name="cancellationToken"></param>
        /// <returns></returns>
        Task<PagedDto<KnowledgeApplyPageDto>> GetApplyHandleList(KnowledgeHandlePagedDto pagedDto, CancellationToken cancellationToken);
    }
}
